<html><head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    <title>linregr</title>
    <style type="text/css" media="all">
      @import url("scilab_code.css");
      @import url("xml_code.css");
      @import url("c_code.css");
      @import url("style.css");
    </style>
  </head>
  <body>
    <div class="manualnavbar">
    <table width="100%"><tr>
      <td width="30%">
    	<span class="previous"><a href="fullfact.html">&lt;&lt; fullfact</a></span>

      </td>
      <td width="40%" class="center">
      	<span class="top"><a href="section_f29eb84a4bb31f3135768cacf4cf6c59.html">Regression tools (regtools)</a></span>

      </td>
      <td width="30%" class="next">
      	<span class="next"><a href="nlinlsq.html">nlinlsq &gt;&gt;</a></span>

      </td>
    </tr></table>
      <hr />
    </div>



    <span class="path"><a href="index.html">Regression tools (regtools)</a> &gt;&gt; <a href="section_f29eb84a4bb31f3135768cacf4cf6c59.html">Regression tools (regtools)</a> &gt; linregr</span>

    <br /><br />
    <div class="info"></div>

  <div class="refnamediv"><h1 class="refname">linregr</h1><p class="refpurpose">An interactive tool for carrying out multi linear regression.</p></div>



<div class="refsynopsisdiv"><h3 class="title">Calling Sequence</h3>
   <div class="synopsis"><pre><span class="functionid">linregr</span><span class="default">()           </span><span class="comment">// start linregr with some demo data in interactive mode...</span>
<span class="functionid">linregr</span><span class="default">(</span><span class="default">Data</span><span class="default">[,</span><span class="default">Names</span><span class="default">]) </span><span class="comment">// Start in interactive mode using the data set Data (with optional column names Names)</span>
<span class="default">[</span><span class="default">beta</span><span class="default">,</span><span class="default">stat</span><span class="default">]=</span><span class="functionid">linregr</span><span class="default">(</span><span class="default">Data</span><span class="default">,</span><span class="default">Names</span><span class="default">,</span><span class="default">Zdef</span><span class="default">,</span><span class="default">Ydef</span><span class="default">[,</span><span class="default">alfa</span><span class="default">]) </span><span class="comment">// run in silent command line mode - returning the results as variables.</span></pre></div></div>

<div class="refsection"><h3 class="title">Parameters</h3>
   <dl><dt><span class="term">Data :</span>
      <dd><p class="para">matrix containing experimental variables as column vectors.</p></dd></dt>
   <dt><span class="term">Names:</span>
      <dd><p class="para">optional space separated string containing names for each column in Data. Each name must be a valid name for a Scilab variable.</p></dd></dt>
   <dt><span class="term">Zdef:</span>
      <dd><p class="para">optional space separated string defining the linear regression matrix Z</p></dd></dt>
   <dt><span class="term">Ydef:</span>
      <dd><p class="para">optional space separated string defining the dependent variable</p></dd></dt>
   <dt><span class="term">alfa:</span>
      <dd><p class="para">optional significance level (default = 0.05) for the parameter confidence interval estimate.</p></dd></dt>
   <dt><span class="term">beta:</span>
      <dd><p class="para">parameter estimates (only in command line mode).</p></dd></dt>
   <dt><span class="term">stat:</span>
      <dd><p class="para">data structure with various statistical results (only in command line mode).</p></dd></dt>
   <dt><span class="term">stat.Z:</span>
      <dd><p class="para">dependent variable matrix</p></dd></dt>
   <dt><span class="term">stat.ZTZ:</span>
      <dd><p class="para">ZTZ=Z&#0039;*Z;</p></dd></dt>
   <dt><span class="term">stat.cov:</span>
      <dd><p class="para">cov=inv(ZTZ); // covariance matrix</p></dd></dt>
   <dt><span class="term">stat.b:</span>
      <dd><p class="para">b=cov*Z&#0039;*Y; // linear regression parameters</p></dd></dt>
   <dt><span class="term">stat.bint:</span>
      <dd><p class="para">bint=cdft(&#0039;T&#0039;,n-p,1-alfa/2,alfa/2)*sqrt(diag(cov)); // confidence interval for b</p></dd></dt>
   <dt><span class="term">stat.bdev:</span>
      <dd><p class="para">bdev=sqrt(diag(cov))*SSxy; // Standard deviation of estimate</p></dd></dt>
   <dt><span class="term">stat.Yhat:</span>
      <dd><p class="para">Yhat=Z*b; // estimate of Y</p></dd></dt>
   <dt><span class="term">stat.Y:</span>
      <dd><p class="para">dependent observations</p></dd></dt>
   <dt><span class="term">stat.resid:</span>
      <dd><p class="para">resid=Y-Yhat; // residuals</p></dd></dt>
   <dt><span class="term">stat.SSr:</span>
      <dd><p class="para">SSr=resid&#0039;*resid; // residual error</p></dd></dt>
   <dt><span class="term">stat.Ybar:</span>
      <dd><p class="para">Ybar=mean(Y); // average Y</p></dd></dt>
   <dt><span class="term">stat.SSt:</span>
      <dd><p class="para">SSt=(Y-Ybar)&#0039;*(Y-Ybar); // variance of the data points Y about mean(Y)</p></dd></dt>
   <dt><span class="term">stat.SSe:</span>
      <dd><p class="para">SSe=(Yhat-Ybar)&#0039;*(Yhat-Ybar); // variance of the estimates Yhat about mean(Y)</p></dd></dt>
   <dt><span class="term">stat.SSxy:</span>
      <dd><p class="para">SSxy=sqrt(SSr/(n-p)); // standard error of estimates of y on x</p></dd></dt>
   <dt><span class="term">stat.SSy:</span>
      <dd><p class="para">SSy=sqrt(SSt/length(Y));</p></dd></dt>
   <dt><span class="term">stat.R2:</span>
      <dd><p class="para">R2=1-SSr/SSt; // R^2 of multiple correlation of y on all x</p></dd></dt>
   <dt><span class="term">stat.R2adj:</span>
      <dd><p class="para">R2adj=1-SSr/SSt*(n-1)/(n-p-1); // R2 adjusted for the number of regression variables</p></dd></dt></dl></div>

<div class="refsection"><h3 class="title">Description</h3>
   <p class="para">linregr is a user friendly tool for analysing data using multi linear regression.</p>
   <p class="para">In interactive mode a graphical user interface is presented and statistical results from
regression analysis is presented in the Scilab Console window.</p>
   <p class="para">When run in silent command line mode the results are returned as the parameters beta and stat.
In this mode no statistical information is displayed in the Scilab Console window.</p>
   <p class="para">See the Scilab Demonstrations section for some linear regression test problems from
the NIST StRD Dataset Archives.</p>
   <p class="para"></p></div>

<div class="refsection"><h3 class="title">Examples</h3>
   <div class="programlisting"><table border="0" width="100%"><tr><td width="98%"><pre class="scilabcode"><span class="scilabid">X</span><span class="scilaboperator">=</span><span class="scilabopenclose">[</span><span class="scilabnumber">0</span><span class="scilabspecial">:</span><span class="scilabnumber">.1</span><span class="scilabspecial">:</span><span class="scilabnumber">2</span><span class="scilaboperator">*</span><span class="scilabconstants">%pi</span><span class="scilabopenclose">]</span><span class="scilaboperator">&#0039;</span><span class="scilabdefault">;</span> <span class="scilabid">Y</span><span class="scilaboperator">=</span><span class="scilabopenclose">[</span><span class="scilabid">X</span><span class="scilaboperator">+</span><a class="scilabcommand" href="scilab://rand">rand</a><span class="scilabopenclose">(</span><span class="scilabid">X</span><span class="scilabopenclose">)</span><span class="scilaboperator">+</span><span class="scilabid">X</span><span class="scilaboperator">.^</span><span class="scilabnumber">2</span><span class="scilaboperator">+</span><span class="scilabnumber">10</span><span class="scilaboperator">*</span><a class="scilabcommand" href="scilab://sin">sin</a><span class="scilabopenclose">(</span><span class="scilabid">X</span><span class="scilabopenclose">)</span><span class="scilabopenclose">]</span><span class="scilabdefault">;</span>
<span class="scilabopenclose">[</span><span class="scilabid">b</span><span class="scilabdefault">,</span><span class="scilabid">stat</span><span class="scilabopenclose">]</span><span class="scilaboperator">=</span><span class="scilabid">linregr</span><span class="scilabopenclose">(</span><span class="scilabopenclose">[</span><span class="scilabid">Y</span> <span class="scilabid">X</span><span class="scilabopenclose">]</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">y x</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">x x.^2 sin(x)</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">y</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span>  <span class="scilabcomment">// solve problem in command line mode</span>

<span class="scilabcomment">// Example from http://en.wikipedia.org/wiki/Simple_linear_regression</span>
<span class="scilabid">Height</span><span class="scilaboperator">=</span><span class="scilabopenclose">[</span><span class="scilabnumber">1.47</span><span class="scilabdefault">,</span> <span class="scilabnumber">1.50</span><span class="scilabdefault">,</span> <span class="scilabnumber">1.52</span><span class="scilabdefault">,</span> <span class="scilabnumber">1.55</span><span class="scilabdefault">,</span> <span class="scilabnumber">1.57</span><span class="scilabdefault">,</span> <span class="scilabnumber">1.60</span><span class="scilabdefault">,</span> <span class="scilabnumber">1.63</span><span class="scilabdefault">,</span> <span class="scilabnumber">1.65</span><span class="scilabdefault">,</span> <span class="scilabnumber">1.68</span><span class="scilabdefault">,</span> <span class="scilabnumber">1.70</span><span class="scilabdefault">,</span> <span class="scilabnumber">1.73</span><span class="scilabdefault">,</span> <span class="scilabnumber">1.75</span><span class="scilabdefault">,</span> <span class="scilabnumber">1.78</span><span class="scilabdefault">,</span> <span class="scilabnumber">1.80</span><span class="scilabdefault">,</span> <span class="scilabnumber">1.83</span><span class="scilabopenclose">]</span><span class="scilaboperator">&#0039;</span><span class="scilabdefault">;</span>
<span class="scilabid">Weight</span><span class="scilaboperator">=</span><span class="scilabopenclose">[</span><span class="scilabnumber">52.21</span><span class="scilabdefault">,</span> <span class="scilabnumber">53.12</span><span class="scilabdefault">,</span> <span class="scilabnumber">54.48</span><span class="scilabdefault">,</span> <span class="scilabnumber">55.84</span><span class="scilabdefault">,</span> <span class="scilabnumber">57.20</span><span class="scilabdefault">,</span> <span class="scilabnumber">58.57</span><span class="scilabdefault">,</span> <span class="scilabnumber">59.93</span><span class="scilabdefault">,</span> <span class="scilabnumber">61.29</span><span class="scilabdefault">,</span> <span class="scilabnumber">63.11</span><span class="scilabdefault">,</span> <span class="scilabnumber">64.47</span><span class="scilabdefault">,</span> <span class="scilabnumber">66.28</span><span class="scilabdefault">,</span> <span class="scilabnumber">68.10</span><span class="scilabdefault">,</span> <span class="scilabnumber">69.92</span><span class="scilabdefault">,</span> <span class="scilabnumber">72.19</span><span class="scilabdefault">,</span> <span class="scilabnumber">74.46</span><span class="scilabopenclose">]</span><span class="scilaboperator">&#0039;</span><span class="scilabdefault">;</span>
<span class="scilabid">linregr</span><span class="scilabopenclose">(</span><span class="scilabopenclose">[</span><span class="scilabid">Weight</span> <span class="scilabid">Height</span><span class="scilabopenclose">]</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">Weight Height</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span> <span class="scilabcomment">// Interactive mode</span></pre></td><td valign="top"><a href="scilab://scilab.execexample/"><img src="ScilabExecute.png" border="0"/></a></td><td valign="top"><a href="scilab://scilab.editexample/"><img src="ScilabEdit.png" border="0"/></a></td><td></td></tr></table></div></div>

<div class="refsection"><h3 class="title">See also</h3>
   <ul class="itemizedlist"><li class="member"><a href="nlinregr.html" class="link">nlinregr</a></li>
   <li class="member"><a href="nlinlsq.html" class="link">nlinlsq</a></li></ul></div>

<div class="refsection"><h3 class="title">Bibliography</h3>
   <p class="para">http://en.wikipedia.org/wiki/Regression_analysis</p>
   <p class="para">NIST StRD Dataset Archives - Linear regression: http://www.itl.nist.gov/div898/strd/general/dataarchive.html</p></div>

<div class="refsection"><h3 class="title">Authors</h3>
   <ul class="itemizedlist"><li class="member">T. Pettersen, top@tpett.com</li></ul></div>


    <div class="manualnavbar">
    <table width="100%"><tr>
      <td width="30%">
    	<span class="previous"><a href="fullfact.html">&lt;&lt; fullfact</a></span>

      </td>
      <td width="40%" class="center">
      	<span class="top"><a href="section_f29eb84a4bb31f3135768cacf4cf6c59.html">Regression tools (regtools)</a></span>

      </td>
      <td width="30%" class="next">
      	<span class="next"><a href="nlinlsq.html">nlinlsq &gt;&gt;</a></span>

      </td>
    </tr></table>
      <hr />
    </div>
  </body>
</html>
